> For the complete documentation index, see [llms.txt](https://docs.luciq.ai/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.luciq.ai/react-native/setup-luciq-for-react-native/logs-and-profiling/custom-spans.md).

# Custom Spans

Create custom spans in your React Native app with Luciq to measure performance of specific code sections. Identify bottlenecks and optimize critical paths.

#### Overview

Custom Spans allow you to manually instrument parts of your application and measure how long specific operations take. This helps you track performance for specific spans that are not automatically captured.

Custom spans appear in the Spans timeline alongside automatically collected spans. They will appear inside all APM metrics we already capture such as app launches, screen loading, network logs and Flows. The backend correlates the custom span with its respective metrics based on their timestamps.

#### Setup Custom Spans

To log a new custom spans, please use the below APIs

{% tabs %}
{% tab title="Javascript" %}

```javascript
let span = await APM.startCustomSpan(name: String); 

span.end()
```

{% endtab %}
{% endtabs %}

To log a completed span, use the below API

{% tabs %}
{% tab title="Javascript" %}

```javascript
APM.addCompletedCustomSpan(name: String, startDate: Date, endDate: Date)

```

{% endtab %}
{% endtabs %}

{% hint style="info" %}
Considerations for creating Custom Spans

1. APM must be enabled to use Custom Spans
2. Luciq SDK must be initialized before calling the API
3. Custom span name cannot be empty
4. Maximum **100 spans per session** (older spans may be dropped if the limit is exceeded
   {% endhint %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.luciq.ai/react-native/setup-luciq-for-react-native/logs-and-profiling/custom-spans.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
